<?php
// $Id: page.inc,v 1.1 2006/09/06 19:37:02 nedjo Exp $

/**
 * Implementation of hook_load().
 */
function formbuilderpage_page_load($node) {
  $formbuilderpage = db_fetch_object(db_query('SELECT * FROM {formbuilderpage} WHERE vid = %d', $node->vid));
  $formbuilderpage->formbuilder_id = $formbuilderpage->form_id;
  return $formbuilderpage;
}

/**
 * Implementation of hook_form().
 */
function formbuilderpage_page_form(&$node) {
  $form['title'] = array(
    '#type' => 'textfield',
    '#title' => t('Title'),
    '#required' => TRUE,
    '#default_value' => $node->title,
    '#weight' => -5
  );
  $form['body_filter']['body'] = array(
    '#type' => 'textarea',
    '#title' => t('Introduction'),
    '#description' => t('Write an introduction to your form, if desired. This will be displayed above your form.'),
    '#default_value' => $node->body,
    '#rows' => 20,
  );
  $form['body_filter']['format'] = filter_form($node->format);

  $form['formbuilder_id'] = array(
    '#type' => 'select',
    '#title' => t('Form'),
    '#description' => t('Select the id of the form you wish to use.'),
    '#options' => drupal_map_assoc(formbuilderpage_list_forms()),
    '#default_value' => $node->formbuilder_id,
  );
  $form['once_only'] = array(
    '#type' => 'select',
    '#title' => t('One submission per user'),
    '#description' => t('Do you wish to limit submissions to one per user?'),
    '#options' => array(t('No'), t('Yes')),
    '#default_value' => $node->once_only,
  );
  return $form;
}

/**
 * Implementation of hook_view().
 *
 * Add the appropriate form to the node body.
 */
function formbuilderpage_page_view(&$node, $teaser = FALSE, $page = FALSE) {

  $node = node_prepare($node, $teaser);
  // Load the form registered to this node.
  $form = formbuilderpage_load_form($node->formbuilder_id);

  // Pass the nid with the form so it can be saved with the form submission.
  $form['form_node'] = array(
    '#type' => 'value',
    '#value' => $node->nid,
  );
  $form['once_only'] = array(
    '#type' => 'value',
    '#value' => $node->once_only,
  );
  $form['#method'] = 'post';
  $form['#action'] = url($_GET['q']);
  $node->body .= drupal_get_form('formbuilderpage_page_form', $form);
}

/**
 * Implementation of hook_insert().
 */
function formbuilderpage_page_insert($node) {
  db_query("INSERT INTO {formbuilderpage} (nid, vid, form_id, once_only) VALUES (%d, %d, '%s', %d)", $node->nid, $node->vid, $node->formbuilder_id, $node->once_only);
}

/**
 * Implementation of hook_update().
 */
function formbuilderpage_page_update($node) {
  if ($node->revision) {
    formbuilderpageinsert($node);
  }
  else {
    db_query("UPDATE {formbuilderpage} SET form_id = '%s', once_only = %d WHERE vid = %d", $node->formbuilder_id, $node->once_only, $node->vid);
  }
}

/**
 * Implementation of hook_delete().
 */
function formbuilderpage_page_delete(&$node) {
  db_query('DELETE FROM {formbuilderpage} WHERE nid = %d', $node->nid);
}

/**
 * Handle the submission of a formbuilder form.
 */
function formbuilderpage_page_form_submit($form_id, $form_values) {
  global $user;
  $node = new StdClass();
  $node->uid = $user->uid;
  $node->title = t('Submission by %user', array('%user' => $user->name));
  $node->type = 'formbuilderpage_submission';
  $node->form_node = $form_values['form_node'];
  unset($form_values['form_node']);
  $node->form_values = serialize($form_values);
  // Determine if the node can be submitted once only per user.
  if ($node->once_only) {
    // If so, determine if this is an update to an existing submission.
    if ($nid = db_result(db_query("SELECT n.nid FROM {node} n INNER JOIN {formbuilderpage_submission} s ON n.nid = s.nid WHERE n.uid = %d AND s.form_node = %d", $node->uid, $node->form_node))) {
      $node->nid = $nid;
      $node->revision = TRUE;
    }
  }
  $node = node_save($node);
  
}